/*****************************************************************************
 *
 * Atmel Corporation
 *
 * ̧		: JobInfo.hpp
 * ߲	: Dev-C++ 4.9.8.0 - http://bloodshed.net/dev/
 * 		: $Revision: 1163 $
 * t		: $Date: 2006N82 15:38:16 +0200 $
 * XV	: $Author: ohlia $
 *
 * xҰ	: avr@atmel.com
 *
 * ړI	: Win32
 *
 * pLq	: AVR911 - AVRJ݊
 *
 * 		: AVRJ݊킪sׂێ׽B͖̏
 *			  sh܂B
 *
 ****************************************************************************/

#ifndef JOBINFO_HPP
#define JOBINFO_HPP

using namespace std;

#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include "ErrorMsg.hpp"
#include "AVRProgrammer.hpp"
#include "AVRBootloader.hpp"
#include "AVRInSystemProg.hpp"
#include "AVRDevice.hpp"
#include "SerialPort.hpp"
#include "Utility.hpp"

class JobInfo
{
	protected:
		long convertHex( char * txt );
		void help();
		void doDeviceIndependent( AVRProgrammer * prog );
		void doDeviceDependent( AVRProgrammer * prog, AVRDevice * avr );

		bool showHelp;							// ߉ʕ\?
		bool silentMode;						// ͏o͂Ȃ(Î⓮)?
		bool noProgressIndicator;				// i\\?
		bool readSignature;						// ʂɎ[޲ďo?
		bool chipErase;							// ǂꂩ̏ݑ̑Oߏ?
		bool getHWrevision;						// ݊ʰ޳ԍ擾?
		bool getSWrevision;						// ݊ĳԍ擾?
		bool programFlash;						// ׯ݊]?
		bool programEEPROM;						// EEPROM݊]?
		bool readFlash;							// ׯǂݏo]?
		bool readEEPROM;						// EEPROMǂݏo]?
		bool verifyFlash;						// ׯƍ]?
		bool verifyEEPROM;						// EPROMƍ]?
		bool readLockBits;						// {ޯēǂݏo]?
		bool readFuseBits;						// ˭ ޯēǂݏo]?
		bool readOSCCAL;						// -OgpꂽꍇɎw肳ꂽOSCCALlǂݍ݂܂͎gp?

		string deviceName;						// w肳ꂽ޲
		string inputFileFlash;					// ׯ݂܂͏ƍp̧̓
		string inputFileEEPROM;					// EEPROM݂܂͏ƍp̧̓
		string outputFileFlash;					// ׯǂݏopo̧
		string outputFileEEPROM;				// EEPROMǂݏopo̧

		long OSCCAL_Parameter;					// -OҰ̒lAw̏ꍇ-1

		long OSCCAL_FlashAddress;				// ׯOSCCALluꏊAȂ̏ꍇ-1
		long OSCCAL_EEPROMAddress;				// EEPROMOSCCALluꏊAȂ̏ꍇ-1

		long programLockBits;					// ̒lɎ{ޯĕύXAȂ̏ꍇ-1
		long verifyLockBits;					// ̒lƑΏƂĎ{ޯĂƍAȂ̏ꍇ-1

		long programFuseBits;					// ̒l˭ ޯĕύXAȂ̏ꍇ-1
		long programExtendedFuseBits;			// g˭ ޯĂɊւē
		long verifyFuseBits;					// ̒lƑΏƂ˭ ޯĂƍAȂ̏ꍇ-1
		long verifyExtendedFuseBits;			// g˭ ޯĂɊւē

		long memoryFillPattern;					// wʒu𖞂AȂ̏ꍇ-1

		long flashStartAddress;					// ׯ쐧(Jnڽ)AȂ̏ꍇ-1
		long flashEndAddress;					// ׯ쐧(Iڽ)AȂ̏ꍇ-1

		long eepromStartAddress;				// EEPROMɊւē
		long eepromEndAddress;					// 

		long comPort;							// gp߂ꂽCOM߰āAwꍇ-1

		vector<string> searchpath;				// XMĻق̂߂߽̌

	public:
		JobInfo();									// ݽ׸

		void parseCommandline( int argc, char *argv[] );
		void doJob();
};

#endif
