/*****************************************************************************
 *
 * Atmel Corporation
 *
 * ̧		: Utility.hpp
 * ߲	: Dev-C++ 4.9.8.0 - http://bloodshed.net/dev/
 * 		: $Revision: 1163 $
 * t		: $Date: 2006N82 15:38:16 +0200 $
 * XV	: $Author: ohlia $
 *
 * xҰ	: avr@atmel.com
 *
 * ړI	: Win32
 *
 * pLq	: AVR911 - AVRJ݊
 *
 * 		: AVROSPŎgpXGհèè ҿނێ׽
 *
 ****************************************************************************/

#ifndef UTILITY_HPP
#define UTILITY_HPP

using namespace std;

#ifndef NOREGISTRY
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#endif

#include <vector>
#include <string>
#include "ErrorMsg.hpp"

class Utility
{
	protected:
		bool noLog;
		bool noProgress;

	public:
		/* ݽ׸ */
		Utility();

		/* ޽׸ */
		~Utility();

		/* ҿ */
		void muteLog() { noLog = true; }
		void muteProgress() { noProgress = true; }

		void log( const string & txt );
		void progress( const string & txt );

		long convertHex( const string & txt );
		string convertLong( long num, long radix = 10 );

		void parsePath( vector<string> & list );
		bool fileExists( string filename );
		void saveString( string txt, string filename );

#ifndef NOREGISTRY
		string getRegistryValue( const string & path, const string & value );
#endif
};

extern Utility Util;

#endif
