/* ISO C9x  7.18  ^ <stdint.h>
 * ISO/IEC SC22/WG14 9899 ψ (SC22 N2794)Ɋ
 *
 * ̿ĳɂ͒쌠܂B
 *
 * e: ATMEL Norway AS
 *
 * ̿ ނ͌Ɏgp邽߂ɒ񋟂Ă܂BRɎgpAύXAzzł
 * ܂B
 *
 * ̺ނ͂ꂪ𗧂Ƃ]ŔzzĂ܂A̕ۏ؂܂B
 * yшÎIȑSĂ̕ۏ؂͂ɂĕ܂Bɂ͏pړI
 * ɊւK̕ۏ؂܂݂܂A͂܂B
 *
 * t: 2005N1220
 */

#ifndef _STDINT_H
#define _STDINT_H
#include <stddef.h>

/* 7.18.1.1 ȕ̐^ */
typedef signed char			int8_t;
typedef unsigned char		uint8_t;
typedef signed short		int16_t;
typedef unsigned short		uint16_t;
typedef signed long			int32_t;
typedef unsigned long		uint32_t;
typedef signed long long	int64_t;
typedef unsigned long long	uint64_t;

/* 7.18.1.2 ŏ̐^ */
typedef signed char			int_least8_t;
typedef unsigned char		uint_least8_t;
typedef signed short		int_least16_t;
typedef unsigned short		uint_least16_t;
typedef signed long			int_least32_t;
typedef unsigned long		uint_least32_t;
typedef signed long long	int_least64_t;
typedef unsigned long long	uint_least64_t;

/*  7.18.1.3 őŏ̐^
 * SĂ̖ړIɑ΂Ďۂɍőۏ؂ł͂܂B
 * ł816ޯĂ̐ɑ΂Čȕ̌^p܂B
 */
typedef signed char			int_fast8_t;
typedef unsigned char		uint_fast8_t;
typedef signed short		int_fast16_t;
typedef unsigned short		uint_fast16_t;
typedef signed long			int_fast32_t;
typedef unsigned long		uint_fast32_t;
typedef signed long long	int_fast64_t;
typedef unsigned long long	uint_fast64_t;

/* 7.18.1.4 Ώە߲ێ\͂^ */
// IARɂĒ`ς݂ŁA޲ԂňقȂ܂B
//typedef signed int		intptr_t;
//typedef unsigned			uintptr_t;

/* 7.18.1.5 ő啝̐^ */
typedef signed long long	intmax_t;
typedef unsigned long long	uintmax_t;

/* 7.18.2 w蕝̐^ */
#if !defined ( __cplusplus) || defined (__STDC_LIMIT_MACROS)

/* 7.18.2.1 ȕ̐^̌x */
#define INT8_MIN	(-128)
#define INT16_MIN	(-32768)
#define INT32_MIN	(-2147483647 - 1)
#define INT64_MIN	(-9223372036854775807LL - 1)

#define INT8_MAX	127
#define INT16_MAX	32767
#define INT32_MAX	2147483647
#define INT64_MAX	9223372036854775807LL

#define UINT8_MAX	0xff					/* 255U */
#define UINT16_MAX	0xffff					/* 65535U */
#define UINT32_MAX	0xffffffff				/* 4294967295U */
#define UINT64_MAX	0xffffffffffffffffULL	/* 18446744073709551615ULL */

/* 7.18.2.2 ŏ̐^̌x */
#define INT_LEAST8_MIN		INT8_MIN
#define INT_LEAST16_MIN		INT16_MIN
#define INT_LEAST32_MIN		INT32_MIN
#define INT_LEAST64_MIN		INT64_MIN

#define INT_LEAST8_MAX		INT8_MAX
#define INT_LEAST16_MAX		INT16_MAX
#define INT_LEAST32_MAX		INT32_MAX
#define INT_LEAST64_MAX		INT64_MAX

#define UINT_LEAST8_MAX		UINT8_MAX
#define UINT_LEAST16_MAX	UINT16_MAX
#define UINT_LEAST32_MAX	UINT32_MAX
#define UINT_LEAST64_MAX	UINT64_MAX

/* 7.18.2.3 őŏ̐^̌x */
#define INT_FAST8_MIN		INT8_MIN
#define INT_FAST16_MIN		INT16_MIN
#define INT_FAST32_MIN		INT32_MIN
#define INT_FAST64_MIN		INT64_MIN

#define INT_FAST8_MAX		INT8_MAX
#define INT_FAST16_MAX		INT16_MAX
#define INT_FAST32_MAX		INT32_MAX
#define INT_FAST64_MAX		INT64_MAX

#define UINT_FAST8_MAX		UINT8_MAX
#define UINT_FAST16_MAX		UINT16_MAX
#define UINT_FAST32_MAX		UINT32_MAX
#define UINT_FAST64_MAX		UINT64_MAX

/* 7.18.2.4 Ώە߲ێ\͂^̌x */
#define INTPTR_MIN			INT32_MIN
#define INTPTR_MAX			INT32_MAX
#define UINTPTR_MAX			UINT32_MAX

/* 7.18.2.5 ő啝̐^̌x */
#define INTMAX_MIN			INT64_MIN
#define INTMAX_MAX			INT64_MAX
#define UINTMAX_MAX			UINT64_MAX

/* 7.18.3 ̑̐^̌x */
#define PTRDIFF_MAX		((ptrdiff_t)-1)
#define PTRDIFF_MIN		(-PTRDIFF_MAX)

#define SIZE_MAX		((size_t)-1)

#endif /* !defined ( __cplusplus) || defined __STDC_LIMIT_MACROS */

/* 7.18.4 萔pϸ */
#if !defined ( __cplusplus) || defined (__STDC_CONSTANT_MACROS)

/* 7.18.4.1 ŏ萔pϸ */
#define INT8_C(val)		((int8_t) + (val))
#define UINT8_C(val)	((uint8_t) + (val##U))
#define INT16_C(val)	((int16_t) + (val))
#define UINT16_C(val)	((uint16_t) + (val##U))

#define INT32_C(val)	(val##L)
#define UINT32_C(val)	(val##UL)
#define INT64_C(val)	(val##LL)
#define UINT64_C(val)	(val##ULL)

/* 7.18.4.2 ő啝萔pϸ */
#define INTMAX_C(val)	(INT64_C(val))
#define UINTMAX_C(val)	(UINT64_C(val))

#endif /* !defined ( __cplusplus) || defined __STDC_CONSTANT_MACROS */

#endif
